<?
/*
	XTP (XORE TRACKER PHP) 2006
	WRITTEN FOR HIGHSPEED SERVERS THAT ARE CAPABLE EACCELERATOR
	
	CONFIG GUIDELINES (RECOMENDED)
	-----------------------------------------------------------------------------------------------------
	
	RECOMENDED SERVER HARDWARE SPECS:
	LINUX (ANY DISTRO WITHOUT GUI'S)
	AT LEAST 1GB RAM
	AT LEAST P4 3.0 GHZ / OR SIMILAIR XEON ETC..
	
	RECOMENDED SERVER SOFTWARE SPECS:
	PHP4 => FASTER THEN PHP5
	PHP FASTCGI
	LIGHTTPD WITH FASTCGI SUPPORT
	EACCELERATOR (CONFIGURE TO GET THE MOST OUT OF IT)
	
	SERVER CONFIG TIPS:
	TURN OF LOGGING FOR: PHP, EACCELERATOR,LIGHTTPD
	OPTIMIZE YOUR SYSCTL.CONF
	-----------------------------------------------------------------------------------------------------
	Scrape.php: almost no modifications have been made here, we have used implode instead of join
	on line 53 (faster) + a few other small edits
	
*/


// Turn off error reporting
error_reporting(0);

// Cache announce data for 2 minutes (120 seconds) -- Ignored if not supported or uncomment to dissable function call
//@eaccelerator_cache_page($_SERVER['PHP_SELF'].'?GET='.serialize($_GET), 120);


$time = intval((time() % 7680) / 60);

function scrape($file)
{
global $time;

$open_file = fopen($file, "rb+");
flock($open_file, LOCK_EX);
$x = fread($open_file, filesize($file));
$no_peers = intval(strlen($x) / 7);

$j=0;

while($j<$no_peers)
{
		$j++;
		$t_peer_seed = implode('', unpack("C", substr($x, $j * 7, 1)));
		if($t_peer_seed >= 128)
		{
			$complete++;
			$t_time = $t_peer_seed - 128;
		}
		else
		{
			$incomplete++;
			$t_time = $t_peer_seed;
			
		}
		if($time - 40 <= $t_time && $time >= $t_time || $time + 88 < $t_time)
		{
			$new_data .= substr($x, $j * 7, 7);
		}
	}

	if($complete + $incomplete > 0)
	{
		$o .= '20:' . pack("H*", $file) . 'd8:completei' . (int)$complete . 'e10:incompletei' . (int)$incomplete . 'ee';
	}
	rewind($open_file);
	ftruncate($open_file, 0);
	fwrite($open_file, $new_data);
	flock($open_file, LOCK_UN);
	fclose($open_file);
	return $o;
}


if($_GET['info_hash'])
{
	echo 'd5:filesd';
	$info_hash = $_GET['info_hash'];
	if(strlen($info_hash) != 20)
	{
		$info_hash = stripcslashes($_GET['info_hash']);
	}
	if(strlen($info_hash) != 20)
	{
		er('Invalid info_hash');
	}
	$info_hash = bin2hex($info_hash);
	echo scrape($info_hash);
	die('ee');
}
else
{
	if(file_exists('scrape') && filemtime('scrape') > (time() - 60))
	{
		readfile('scrape');
		die();
	}
	else
	{
		$o = 'd5:filesd';
		$open_file = opendir('.');
		while (false !== ($file = readdir($open_file)))
		{
			if(strlen($file) == 40)
			{
				$o .= scrape($file);
			}
		}
		closedir($open_file);
		$o .= 'ee';
		$open_file1 = fopen('scrape', "w");
		flock($open_file1, LOCK_EX);
		fwrite($open_file1, $o);
		flock($open_file1, LOCK_UN);
		fclose($open_file1);
		die($o);
	}
}
?>